#
#  Communication Client module for general
#  @Auther: by M.Sekido 
#  @Date:  2007.10.15
#
#
package Com_clt;
use Exporter;
# use lib "$ENV{HOME}/prog/perl/module";
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
#use Term::ANSIScreen qw/:color :cursor :screen :keyboard/;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

DESTROY{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_host($$){
    my $pkg = shift;
    my $tmp = shift;
    if($tmp =~/(\S+):(\S+)/){
	$pkg->{host} = $1;
	$pkg->{port} = $2;
    }else{
	$pkg->{host} = $tmp;
    }
}

sub Set_port($$){
    my $pkg = shift;
    $pkg->{port} = shift;
}

sub Connect($){
    my $pkg = shift;

    my $host = $pkg->{host};
    my $port = $pkg->{port};
    unless(defined($host) && defined($port)){
	printf STDERR 
	    "Error in Com_clt::Connect(): host/port = %s/%s is not sufficent\n",
	    $host,$port;
	return undef;
    }
    my $remote = $pkg->{socket} 
    = IO::Socket::INET->new(Proto    => "tcp",
			    PeerAddr => $host,
			    PeerPort => $port );
    unless(defined($remote)){
	print STDERR "Error: Connection failed to $host:$port \n";
	return -1;
    }
    return $remote;
}

sub Close($){
    my $pkg = shift;
    close($pkg->{socket}) if(defined($pkg->{socket}));
}

1;
